/*
 * Copyright (c) 2018. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.chess.game;

import java.util.ArrayList;
import java.util.List;

import org.hedgecode.chess.position.Color;
import org.hedgecode.chess.position.Square;

/**
 *
 *
 * @author Dmitry Samoshin aka gotty
 */
public class GameMoves implements Moves {

    private int moveNumber;
    private List<Move> moves;

    public GameMoves() {
        moveNumber = -1;
        moves = new ArrayList<>();
    }

    @Override
    public void move(Move move) {

    }

    @Override
    public Move first() {
        if (moves.isEmpty())
            return null;
        moveNumber = 0;
        return moves.get(moveNumber);
    }

    @Override
    public Move last() {
        if (moves.isEmpty())
            return null;
        moveNumber = moves.size() - 1;
        return moves.get(moveNumber);
    }

    @Override
    public boolean hasNext() {
        return moves.size() > moveNumber + 1;
    }

    @Override
    public Move next() {
        if (hasNext())
            return moves.get(++moveNumber);
        return null;
    }

    @Override
    public void clear() {
        moveNumber = -1;
        moves.clear();
    }

    @Override
    public int count() {
        return moves.size();
    }

    @Override
    public Move byNumber(int num, Color color) {
        return null;
    }

    static class Builder {

        Move build(Color color, Square from, Square to) {
            return new GameMove(color, from, to);
        }

    }

}
