/*
 * Copyright (c) 2018. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.chess.position;

import java.util.HashMap;
import java.util.Map;

/**
 *
 *
 * @author Dmitry Samoshin aka gotty
 */
public class GamePosition extends DiagramPosition {

    private Map<Color, Castle> castles = new HashMap<Color, Castle>(){
        {
            put(Color.WHITE, Castle.NONE);
            put(Color.BLACK, Castle.NONE);
        }
    };

    private int halfMove;
    private int fullMove;

    private Square enPassant;

    @Override
    public boolean isDiagram() {
        return false;
    }

    @Override
    public Castle getCastle(Color color) {
        return castles.get(color);
    }

    @Override
    public void setCastle(Color color, Castle castle) {
        castles.put(color, castle);
    }

    @Override
    public Square getEnPassant() {
        return enPassant;
    }

    @Override
    public void setEnPassant(Square square) {
        enPassant = square;
    }

    @Override
    public int getHalfMove() {
        return halfMove;
    }

    @Override
    public void setHalfMove(int count) {
        halfMove = count;
    }

    @Override
    public int getFullMove() {
        return fullMove;
    }

    @Override
    public void setFullMove(int number) {
        fullMove = number;
    }

}
