/*
 * Copyright (c) 2018. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.chess.persistence;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.hedgecode.chess.EtudeConstants;

/**
 *
 *
 * @author Dmitry Samoshin aka gotty
 */
public final class PersistenceUtils {

    public static EntityManagerFactory createEntityManagerFactory() {
        return Persistence.createEntityManagerFactory(
                EtudeConstants.PERSISTENCE_UNIT_NAME
        );
    }

    private PersistenceUtils() {
        throw new AssertionError(
                "No org.hedgecode.chess.persistence.PersistenceUtils instances!"
        );
    }

}
