/*
 * Copyright (c) 2018. Developed by Hedgecode.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.hedgecode.chess.uci;

import java.util.List;

/**
 * Universal Chess Interface (UCI) Acceptor.
 *
 * @author Dmitry Samoshin aka gotty
 */
public interface Acceptor {

    void start();

    void id(String params);

    void uciOK(String params);

    void readyOK(String params);

    void setOption(String name);
    void setOption(String name, boolean def);
    void setOption(String name, int def, int min, int max);
    void setOption(String name, String def);
    void setOption(String name, String def, List<String> vars);

    void terminate(String params);

}
